QGIS Application - Bug report #14136
Error on opening project file on 2.13 (nightly development build)
2016-01-19 12:58 AM - Michal Jurewicz

Status: Closed

Priority: High

Assignee: Sebastian Dietrich

Category: Project Loading/Saving

Affected QGIS version:master Regression?: No
Operating System: Easy fix?: No
Pull Request or Patch supplied: Resolution:

Crashes QGIS or corruptsdata: Copied to github as #: 22138
Description

I don't know it is good place to report some error which occurs on developer builds but | can't find any better. I'm using build for OS X from
Dakota Cartography because | can't find any actual stable binary for OS X. On KyngChaos last stable version is 2.12.1 and there is some
bugs which makes me this version unusable.

QGIS 2.13 ed32f49 worked fine for me for last few days. However, yesterday a have saved my project file and today | couldn't open it.
There was error: unexpected character in line 146522 in column 22 in project file. It is this line: <config doktadne reko="doktadne reko"
oflagowany="oflagowany" otasmowany="otasmowany" NULL="NULL"/>

| have deleted whole line with 1 parent tag:
<widget name="Status">
<config doktadne reko="doktadne reko" oflagowany="oflagowany" otasmowany="otasmowany" NULL="NULL"/>
</widget>

| believe it is definition of rule based style format on table (I recognize attribute names) and there is problem with UTF8 special character
ll{ll

After deleting this line, project file is ok and everything works.

Associated revisions

Revision e99ccb79 - 2016-02-20 03:39 PM - Sebastian Dietrich

remove the accompanying QgsEditorWidgetConfig when removing a field
(refs #14136)

Revision 50aa8058 - 2016-02-23 11:11 AM - Matthias Kuhn

Merge pull request #2778 from SebDieBIn/FixOrphanedWidgetConfigs

[Bugfix] Avoid orphaned QgsEditorWidgetConfig (refs #14136)

Revision 58751b50 - 2016-02-23 11:25 AM - Matthias Kuhn

Don't use invalid xml values as attribute names

Fixes #14136
History

#1 - 2016-01-19 01:37 PM - Sebastian Dietrich
- Category set to Project Loading/Saving

I don't know it is good place to report some error which occurs on developer builds but | can't find any better.

It is exactly the right place!

QGIS 2.13 ed32f49

+1 for specifying which master you were testing :-)
You can also attach files to this ticket, e.g. your broken project file might be of some help investigating this issue. Please make sure not to reveal any

passwords that might be stored in your project.

#2 - 2016-01-19 02:00 PM - Saber Razmjooei

- Operating System deleted (OS X)

- OS version deleted (10.11.2)

| have tested it in Windows using latest master.

While the UTF special charector did not crash QGIS upon opening the project, after saving and opening the project, the attribute table came up with wrong

format.

#3 - 2016-01-19 02:04 PM - Saber Razmjooei
- Subject changed from Error on opening project file on 2.13 (nightly development build) to Attribute table formating can't handle UTF8 specialr
characters

- Category changed from Project Loading/Saving to Attribute table

#4 - 2016-01-19 02:05 PM - Saber Razmjooei

- Subject changed from Attribute table formating can't handle UTF8 specialr characters to Attribute table formating can't handle UTF8 special characters

#5 - 2016-01-19 04:06 PM - Sebastian Dietrich

Saber Razmjooei wrote:

While the UTF special charector did not crash QGIS upon opening the project, after saving and opening the project, the attribute table came up with

wrong format.

That is interesting, too, but it is not what the OP mentioned:

unexpected character in line 146522 in column 22 in project file

So I would kindly ask you to file a new ticket for that and please change the subject of this ticket back to its former value.

The original error is not caused by the UTF special character, but by the "attribute name" doktadne reko. That contains a space and thus makes is two
attributes, dokfadne and reko, with the first one having no value. That is a violation of the XML-standard and thus the file can not be opened.
https://www.w3.org/TR/xml/#sec-starttags

#6 - 2016-01-19 04:34 PM - Sebastian Dietrich

- Status changed from Open to Feedback

- Category changed from Attribute table to Project Loading/Saving

@Michal Jurewicz:

Please attach the broken project file.

#7 - 2016-01-20 12:33 AM - Saber Razmjooei

Michal,

Could you try the followings and report back:

1- saving and opening a project without the conditional formating to your table
2- saving and opening a project with conditional formating to a table without UTF8 special characters
Thanks

Saber

#8 - 2016-01-20 04:50 AM - Sebastian Dietrich

OK, I think | found the offending line in the code. It seems the attribute name is derived from some user input and not checked to be a valid attribute name.

Not checking is the default in Qt.

However, | don't know from where the code is called in this case.

@Saber Razmjooei:

Is this related to the conditional formatting you mentioned? What are the steps to have a <config> tag written to the project? | always get <widgetv2config>
tags.

#9 - 2016-01-21 12:46 AM - Michal Jurewicz

Here is my old project file which caused the problem:
https://www.dropbox.com/s/hk54ilfrnm0otc6/Single%20Kaczawskie%20QGIS-kopia.qgs ?dI=0

| realized that this line can be also field definition (attribute map) for a table.

The fixed project file (where | deleted this problematic line) works fine.

#10 - 2016-01-21 05:04 PM - Sebastian Dietrich

Thanks for posting that (huge) project! | can reproduce on current master.

| tracked the error down to the layer called Przebieg v12.
- Do you recall what you changed in that layer before you saved the project?
- It must have something to do with an entity called Status. Is that a field, a relation, or something else?
- Do you remember where you entered the values dokfadne reko, oflagowany, ... ?

| still have troubles finding a QGIS function that saves the
<widget ..>

<config .../>
</widget>
https://github.com/qgis/QGIS/blob/44559fee3b29adc07a8c0d2f460edd7086d8c10c/src/core/qgseditformconfig.cpp#L327
http://doc.qt.io/qt-4.8/qdomimplementation.html#InvalidDataPolicy-enum
https://www.dropbox.com/s/hk54jlfrnm0otc6/Single%20Kaczawskie%20QGIS-kopia.qgs?dl=0

tags to a project :-(

#11 - 2016-01-21 05:12 PM - Sebastian Dietrich

When | remove the offending space in doktadne reko the project loads fine (except for all the broken layers, of course).
@Saber Razmjooei

May | kindly ask you again to

- create a new ticket for the newly discovered UTF8 issue regarding the attribute table

- change the title of this ticket back to its former value

Thanks!

#12 - 2016-01-21 05:40 PM - Sebastian Dietrich
- Status changed from Feedback to Open

OK, | could finally reproduce the error!

- Create a new project

- Create a new memory layer

- Add a field named NewField to the memory layer
- Leave editing mode

- Make the Edit Widget for that field a Value map
- Enterfooas value and b ar as description

- Apply your changes to the layer

- Delete the field NewField

- Save the project

You end up with the following lines in the project:

<widget name="NewField">
<configb ar="fo0"/>

</widget>

This violates the XML-standard and the file will not load in QGIS again.

#13 - 2016-01-23 03:41 PM - Sebastian Dietrich
- Status changed from Open to In Progress
- Assignee set to Sebastian Dietrich

#14 - 2016-01-27 02:10 PM - Sebastian Dietrich
- % Done changed from 0 to 70
- Target version set to Version 2.14

#15 - 2016-02-10 07:48 AM - Sebastian Dietrich
- % Done changed from 70 to 100

- Subject changed from Attribute table formating can't handle UTF8 special characters to Error on opening project file on 2.13 (nightly development
build)
- Pull Request or Patch supplied changed from No to Yes
See PR 2778 for a solution.

#16 - 2016-02-10 09:42 AM - Paolo Cavallini
- Subject changed from Error on opening project file on 2.13 (nightly development build) to Attribute table formating can't handle UTF8 special

characters

#17 - 2016-02-10 11:19 AM - Sebastian Dietrich

- Subject changed from Attribute table formating can't handle UTF8 special characters to Error on opening project file on 2.13 (nightly development
build)

#18 - 2016-02-20 06:47 AM - Sebastian Dietrich

- % Done changed from 100 to 50

Progress reduced to 50% because there might be more ways to trigger the creation of invalid XML and it is not yet clear whether this issue was triggered

by the way | discovered and fixed in PR 2778.

#19 - 2016-02-23 04:25 AM - Anonymous
- Status changed from In Progress to Closed

Fixed in changeset commit:"58751b5063a5538ca2ce476dc812fcb396c6cf8b".
https://github.com/qgis/QGIS/pull/2778
https://github.com/qgis/QGIS/pull/2778

